Index: po4a
===================================================================
RCS file: /cvsroot/po4a/po4a/po4a,v
retrieving revision 1.94
diff -u -r1.94 po4a
--- po4a	15 Jan 2010 21:12:21 -0000	1.94
+++ po4a	19 Jan 2010 19:14:02 -0000
@@ -837,7 +837,12 @@
 	}
 	%{$document{$main}{'options'}} = %options;
 
-	foreach my $arg (split(/ /,$args)) {
+	chdir $po4a_opts{"srcdir"}
+	    if (defined $po4a_opts{"srcdir"});
+	my %discarded = ();
+	my @remaining_args = split(/ /,$args);
+	while (@remaining_args) {
+	    my $arg = shift(@remaining_args);
 	    die wrap_ref_mod("$config_file:$nb", "",
 		gettext("Unparsable argument '%s' (%s)."), $arg, $line)
 	      unless ($arg =~ /^([^:]*):(.*)/);
@@ -846,8 +851,28 @@
 		gettext("The translated and master file are the same."))
 	      if ($main eq $trans);
 
-	    if ($lang =~ /add_/) {
-		push @{$document{$main}{$lang}},$trans;
+	    if ($lang =~ /^add_/) {
+		if ($trans =~ s/^([@!?]+)//) {
+		  my $modifiers = $1;
+		  if ($modifiers =~ m/!/) {
+		    $discarded{$trans} = 1;
+		    next;
+		  }
+		  next if ($modifiers =~ m/\?/ and not -e $trans);
+		  if ($modifiers =~ m/@/) {
+		    open LIST,"<","$trans" or die wrap_msg(gettext("Can't open %s: %s"), $trans, $!);
+		    my @new_list = ();
+		    while(<LIST>) {
+		      chomp;
+		      next if length($_) == 0 or $_ =~ m/^\s*#/;
+		      push(@new_list, "$lang:$_");
+		    }
+		    close LIST;
+		    unshift(@remaining_args, @new_list);
+		  }
+		} elsif (not defined($discarded{$trans})) {
+		  push @{$document{$main}{$lang}},$trans;
+		}
 	    } else {
 		die wrap_ref_mod("$config_file:$nb", "",
 		    gettext("Translation of %s in %s redefined"), $main, $lang)
@@ -855,6 +880,8 @@
 		$document{$main}{$lang} = $trans;
 	    }
 	}
+	chdir $po4a_opts{"calldir"}
+	    if (defined $po4a_opts{"srcdir"});
     } elsif ($cmd =~ m/po4a_alias: *(.*)/) {
 	my $name = $1;
 	my %alias = ();
